"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _yylibUi = require("yylib-ui");

var _antd = require("antd");

var _BaseHost = require("../../BaseHost");

var _BaseHost2 = _interopRequireDefault(_BaseHost);

var _ajax = require("yylib-utils/ajax");

var _ajax2 = _interopRequireDefault(_ajax);

require("../mgrNewDialog.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var QWebChannel = require("../qwebchannel").QWebChannel;
var Dragger = _antd.Upload.Dragger;
var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;

var radioStyle = {
  display: "block",
  height: "30px",
  lineHeight: "30px"
};
var uiMeta = {
  name: "AttachMgrModalNew",
  fields: [
  //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
  //------------附件管理按钮配置------------//
  field("type", "error", PropTypes.oneOf(["primary", "success", "info", "warning", "error", ""]), false, "设置按钮类型，可选值为 primary|success|info|warning|error 或者不设"), field("buttonText", "附件管理", PropTypes.string, false, "设置按钮的文本"), field("icon", "upload", PropTypes.string, false, "设置按钮的图标类型"), field("visible", true, PropTypes.bool, false, "设置按钮是否显示"), field("disabled", false, PropTypes.bool, false, "设置按钮是否禁用"), field("ghost", true, PropTypes.bool, false, "设置按钮为不填充形态")]
};
var imgPath, deletePath;
var AttachMgrModalNew = _yylibUi.YYClass.create({
  uiMeta: uiMeta,
  displayName: "AttachMgrModalNew",
  getInitialState: function getInitialState() {
    return {
      _urlUpload: _BaseHost2.default,
      _urlDownLoad: _BaseHost2.default,
      userId: null,
      userName: null,
      sourceId: null,
      billType: null,
      sourceType: "102345678",
      visible: false,
      visibleHM: false,
      visiblePreview: false,
      imgVideo: "",
      infoNum: 0,
      timeOutNum: 0,
      //   value: 1,
      //   valueMethod: 1,
      videoUrl: "",
      imgPathArray: [], //base64路径，拍摄后显示本地图片
      deletePathArray: [], //删除的绝对路径标注
      deletedArray: [], //确认删除的数组
      deletedLength: 0,
      uploadArray: [],
      uploadFileList: [],
      deviceInfo: "",
      carouselList: [],
      preViewTitle: [],
      preViewTitleIndex: [],
      setTimeoutFlag: false,
      getUploadList: []
    };
  },
  showModalHM: function showModalHM() {
    this.setState({
      visibleHM: true
    });
    this.openSocket();
  },
  handleShowModal: function handleShowModal() {
    var _this2 = this;

    var isPostParams = this.props.postParams ? true : false;
    if (isPostParams) {
      var _res = this.props.postParams();
      var userId = _res.myParams === undefined ? "" : _res.myParams.creatorId;
      var userName = _res.myParams === undefined ? "" : _res.myParams.creatorName;
      var sourceId = _res.myParams === undefined ? "" : _res.myParams.groupId;
      var billType = _res.myParams === undefined ? "" : _res.myParams.billType;
      var sourceType = "102345678";
      console.log(_res.myParams === "undefined");
      this.setState({
        visible: !this.state.visible,
        userId: userId,
        userName: userName,
        sourceId: sourceId,
        billType: billType,
        sourceType: sourceType
      }, function () {
        _this2.getUploadListFn();
      });
    } else {
      this.setState({
        visible: !this.state.visible
      }, function () {
        _this2.getUploadListFn();
      });
    }
  },
  hideModal: function hideModal() {
    this.setState({
      visible: false
    });
  },
  hideModalHM: function hideModalHM() {
    var _this3 = this;

    this.setState({
      visibleHM: false,
      setTimeoutFlag: true,
      imgVideo: ""
    }, function () {
      if (!window.dialog || !dialog) return;
      dialog.get_actionType("closeSignal");
      imgPath = "";
      _this3.getUploadListFn();
    });
  },
  hideModalPreview: function hideModalPreview() {
    this.setState({
      visiblePreview: false
    });
  },
  // 获取文件后缀名
  fileSuffix: function fileSuffix(fileName) {
    var first = fileName.lastIndexOf(".");
    var namelength = fileName.length;
    var filesuffix = fileName.substring(first + 1, namelength);
    return filesuffix;
  },
  // base64转blob
  base64ToBlob: function base64ToBlob(base64Data) {
    var arr = base64Data.split(","),
        fileType = arr[0].match(/:(.*?);/)[1],
        bstr = atob(arr[1]),
        l = bstr.length,
        u8Arr = new Uint8Array(l);

    while (l--) {
      u8Arr[l] = bstr.charCodeAt(l);
    }
    return new Blob([u8Arr], {
      type: fileType
    });
  },
  // blob转file
  blobToFile: function blobToFile(newBlob, fileName) {
    newBlob.lastModifiedDate = new Date();
    newBlob.name = fileName;
    return newBlob;
  },
  openSocket: function openSocket() {
    var _this = this;
    var _state = this.state,
        setTimeoutFlag = _state.setTimeoutFlag,
        infoNum = _state.infoNum;

    var baseUrl = "ws://127.0.0.1:12345";
    var socket = new WebSocket(baseUrl);
    var newInfoNum = infoNum;
    socket.onerror = function (error) {
      if (error.type === "error") {
        newInfoNum += 1;
        console.log(newInfoNum, "newInfoNum------------");
        _this.setState({
          infoNum: newInfoNum
        }, function () {
          if (_this.state.infoNum <= 1) {
            _yylibUi.YYMessage.error("请检查设备驱动,连接后刷新页面尝试");
          }
        });
        if (!setTimeoutFlag) {
          setTimeout(function () {
            _this.openSocket();
          }, 2500);
        }
      }
    };
    socket.onopen = function () {
      new QWebChannel(socket, function (channel) {
        window.dialog = channel.objects.dialog;
        //网页关闭函数
        window.onbeforeunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        window.onunload = function () {
          //发送关闭信号
          dialog.get_actionType("closeSignal");
          //关闭socket
          socket.close();
        };
        //服务器返回消息
        dialog.sendPrintInfo.connect(function (message) {
          //获取文件base64返回值
          if (message.indexOf("fileBase64:") >= 0) {
            var value = message.substr(11);
            alert(value);
            return;
          }
          if (message.indexOf("No equipment found!") >= 0) {
            _yylibUi.YYMessage.error("没有设备,请连接设备");
          }
          // 设备信息
          if (message.indexOf("priDevName:") >= 0) {
            message = message.substr(11);
            if (message.indexOf("USB") < 0) {
              _this.setState({
                deviceInfo: message
              });
            }
          }
          if (message.indexOf("savePhoto_success:") >= 0) {
            deletePath = message.substr(18);
            _this.addImgDiv();
          }
        });
        //接收图片流用来展示，多个，较小的base64数据
        dialog.send_priImgData.connect(function (message) {
          _this.setState({
            imgVideo: "data:image/jpg;base64," + message
          });
          imgPath = "data:image/jpg;base64," + message;
        });
        //网页加载完成信号
        dialog.html_loaded("one");
      });
    };
  },
  // 添加拍照缩略图
  addImgDiv: function addImgDiv() {
    this.setState({
      imgPathArray: this.state.imgPathArray.concat(imgPath),
      uploadArray: this.state.uploadArray.concat(imgPath),
      deletePathArray: this.state.deletePathArray.concat(deletePath),
      deletedArray: this.state.deletedArray.concat(deletePath),
      deletedLength: this.state.deletedLength + 1
    });
  },
  // 拍照
  onClickBtn: function onClickBtn() {
    var timeOutNum = this.state.timeOutNum;

    var _this = this;
    var num = timeOutNum;
    //防止重复点击拍照
    if (num === 0) {
      num = 1;
      this.setState({
        timeOutNum: num
      });
      dialog.photoBtnClicked("primaryDev_");
      dialog.get_actionType("savePhotoPriDev");
      setTimeout(function () {
        _this.setState({
          timeOutNum: 0
        });
      }, 2000);
    }
  },
  // 选中图片
  handleCheckbox: function handleCheckbox(e, name, uploadName) {
    var _state2 = this.state,
        deletedArray = _state2.deletedArray,
        uploadArray = _state2.uploadArray,
        deletedLength = _state2.deletedLength;

    var nameNew = deletedArray;
    var newUploadName = uploadArray;
    if (e.target.checked === true) {
      nameNew = deletedArray.concat(name);
      newUploadName = uploadArray.concat(uploadName);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength + 1
      });
    } else {
      var index = deletedArray.indexOf(name);
      nameNew.splice(index, 1);
      newUploadName.splice(index, 1);
      this.setState({
        deletedArray: nameNew,
        uploadArray: newUploadName,
        deletedLength: deletedLength - 1
      });
    }
  },
  // 删除本地照片
  deleteHandleFile: function deleteHandleFile() {
    var _state3 = this.state,
        deletedArray = _state3.deletedArray,
        imgPathArray = _state3.imgPathArray,
        deletePathArray = _state3.deletePathArray;

    var newPathArr = imgPathArray,
        newDelPathArr = deletePathArray;
    if (!deletedArray.length) {
      _yylibUi.YYMessage.error("没有需要删除的照片");
      return;
    }
    for (var i = 0; i < deletedArray.length; i++) {
      var index = deletePathArray.indexOf(deletedArray[i]);
      newPathArr.splice(index, 1);
      newDelPathArr.splice(index, 1);
      dialog.get_functionTypes("deleteFile", deletedArray[i], "", "");
    }
    this.setState({
      imgPathArray: newPathArr,
      deletePathArray: newDelPathArr,
      deletedArray: [],
      uploadArray: [],
      deletedLength: 0
    });
  },
  //上传按钮
  handleUpload: function handleUpload() {
    var _this4 = this;

    var _state4 = this.state,
        uploadArray = _state4.uploadArray,
        deletedArray = _state4.deletedArray,
        userId = _state4.userId,
        userName = _state4.userName,
        sourceId = _state4.sourceId,
        billType = _state4.billType,
        sourceType = _state4.sourceType,
        _urlUpload = _state4._urlUpload;

    if (!uploadArray.length) {
      _yylibUi.YYMessage.error("请选择要上传的文件");
      return;
    }
    var fileNames = deletedArray.map(function (pathItem) {
      var slices = pathItem.split("\\");
      return slices[slices.length - 1];
    });
    var blobs = uploadArray.map(function (base64Item) {
      return _this4.base64ToBlob(base64Item);
    });
    var files = blobs.map(function (blobsItem, index) {
      return _this4.blobToFile(blobsItem, fileNames[index]);
    });

    var uploadRequest = function uploadRequest(len, index) {
      if (index >= len) {
        _yylibUi.YYMessage.success("上传成功");
        _this4.deleteHandleFile();
        _this4.setState({
          uploadArray: []
        });
        return;
      }
      var formData = new FormData();
      formData.append("sourceId", sourceId);
      formData.append("billType", billType);
      formData.append("sourceType", sourceType);
      formData.append("userId", userId);
      formData.append("userName", userName);
      formData.append("file", files[index], fileNames[index]);
      var xhr = new XMLHttpRequest();
      xhr.onreadystatechange = function () {
        if (xhr.readyState == 4) {
          if (xhr.status == 200) {
            uploadRequest(len, ++index);
          } else {}
        }
      };
      xhr.open("post", _urlUpload + "/icop-file/file/upload2", true);
      xhr.send(formData);
    };
    uploadRequest(files.length, 0);
  },
  // 图片预览
  handlePreview: function handlePreview(file) {
    this.setState({
      previewImage: file.url || file.thumbUrl,
      previewVisible: true
    });
  },
  //展示预览窗
  handlePreviewShowModal: function handlePreviewShowModal(index) {
    this.setState({
      visiblePreview: true
    });
  },
  //获取上传的列表
  getUploadListFn: function getUploadListFn() {
    var _this5 = this;

    var _state5 = this.state,
        _urlUpload = _state5._urlUpload,
        sourceId = _state5.sourceId,
        billType = _state5.billType,
        sourceType = _state5.sourceType;

    _ajax2.default.postJSON(_urlUpload + "/icop-file/file/list?id=" + sourceId + "&billType=" + billType + "&type=" + sourceType, "", function (res) {
      var data = res.backData;
      _this5.setState({
        getUploadList: data
      });
    });
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (!nextProps) return;
    this.getUploadListFn();
  },
  render: function render() {
    var _this6 = this;

    var _props = this.props,
        type = _props.type,
        icon = _props.icon,
        disabled = _props.disabled,
        ghost = _props.ghost,
        buttonText = _props.buttonText;
    var _state6 = this.state,
        _urlUpload = _state6._urlUpload,
        imgVideo = _state6.imgVideo,
        imgPathArray = _state6.imgPathArray,
        deletePathArray = _state6.deletePathArray,
        deletedLength = _state6.deletedLength,
        preViewTitle = _state6.preViewTitle,
        preViewTitleIndex = _state6.preViewTitleIndex,
        getUploadList = _state6.getUploadList,
        deviceInfo = _state6.deviceInfo,
        sourceId = _state6.sourceId,
        billType = _state6.billType,
        sourceType = _state6.sourceType,
        userId = _state6.userId,
        userName = _state6.userName;


    var _this = this;
    var myProps = {
      name: "file",
      listType: "picture",
      showUploadList: false,
      action: _urlUpload + "/icop-file/file/upload2",
      data: {
        sourceId: sourceId,
        billType: billType, //业务单据类型
        sourceType: sourceType, //业务单据文件细分类别标识
        userId: userId,
        userName: userName
      },
      onChange: function onChange(info) {
        var status = info.file.status;

        if (status === "done") {
          var infoList = info.fileList;
          for (var i = 0; i < infoList.length; i++) {
            if (infoList[i].type !== "image/png" && infoList[i].type !== "image/x-icon" && infoList[i].type !== "image/jpeg" && infoList[i].type !== "image/gif") {
              infoList[i].thumbUrl = [require("./file.png")];
            }
          }
          _yylibUi.YYMessage.success(info.file.name + "\u4E0A\u4F20\u6210\u529F");
          _this.setState({
            uploadFileList: infoList,
            carouselList: infoList
          }, function () {
            _this.getUploadListFn();
          });
        } else if (status === "error") {
          _yylibUi.YYMessage.error(info.file.name + "\u4E0A\u4F20\u5931\u8D25");
        }
      }
    };
    return _react2.default.createElement(
      "div",
      {
        style: {
          display: "inline-block",
          position: "relative",
          top: "3px",
          marginRight: "6px"
        }
      },
      _react2.default.createElement(
        _yylibUi.YYButton,
        {
          icon: icon,
          type: type,
          ghost: ghost,
          visible: this.props.visible,
          disabled: disabled,
          onClick: this.handleShowModal
        },
        buttonText
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          className: "upload-con",
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              _yylibUi.YYButton,
              { className: "title-btn", type: "primary", danger: true },
              "\u4E0A\u4F20\u6587\u4EF6"
            ),
            _react2.default.createElement(
              _yylibUi.YYButton,
              { className: "title-btn", onClick: this.showModalHM },
              "\u9AD8\u62CD\u4EEA"
            )
          )],
          visible: this.state.visible,
          footer: null,
          onCancel: this.hideModal
        },
        _react2.default.createElement(
          Dragger,
          _extends({}, myProps, {
            className: "upload-list-inline",
            multiple: true,
            onPreview: this.handlePreview
          }),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-drag-icon" },
            _react2.default.createElement(_antd.Icon, { type: "cloud-upload" })
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-text" },
            "\u70B9\u51FB\u6216\u5C06\u6587\u4EF6\u62D6\u62FD\u5230\u6B64\u533A\u57DF\u4E0A\u4F20"
          ),
          _react2.default.createElement(
            "p",
            { className: "ant-upload-hint" },
            "\u6700\u5927\u652F\u630110MB"
          )
        ),
        _react2.default.createElement(
          "div",
          { className: "upload-list-item" },
          getUploadList ? getUploadList.map(function (item, index) {
            var mapSrc = void 0;
            _this6.fileSuffix(item.fileName) === "png" || _this6.fileSuffix(item.fileName) === "jpeg" || _this6.fileSuffix(item.fileName) === "jpg" || _this6.fileSuffix(item.fileName) === "ico" || _this6.fileSuffix(item.fileName) === "gif" || _this6.fileSuffix(item.fileName) === "bip" || _this6.fileSuffix(item.fileName) === "tiff" || _this6.fileSuffix(item.fileName) === "tga" || _this6.fileSuffix(item.fileName) === "eps" ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
            return _react2.default.createElement(
              "div",
              { key: item.gid, className: "load-list" },
              _react2.default.createElement("img", {
                className: "img-preview",
                title: "\u70B9\u51FB\u9884\u89C8",
                alt: item.fileName,
                src: mapSrc,
                onClick: function onClick() {
                  return _this6.handlePreviewShowModal(index);
                }
              }),
              _react2.default.createElement(
                "a",
                {
                  title: "\u70B9\u51FB\u4E0B\u8F7D",
                  href: _urlUpload + "/" + item.filePath + "?filename=" + item.fileName,
                  download: item.fileName
                },
                item.fileName
              )
            );
          }) : _react2.default.createElement(
            "div",
            null,
            "\u6CA1\u6709\u6587\u4EF6"
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          width: "100%",
          className: "high-meter-con",
          style: {
            height: "100%",
            position: "absolute",
            margin: 0,
            top: 0,
            transformOrigin: 0,
            paddingBottom: 0
          },
          title: [_react2.default.createElement(
            "div",
            null,
            _react2.default.createElement(
              "span",
              null,
              "\u9AD8\u62CD\u6444\u5F71\u4EEA\uFF1A"
            ),
            _react2.default.createElement(
              "span",
              { className: "switch-btn" },
              deviceInfo
            )
          )],
          visible: this.state.visibleHM,
          footer: null,
          onCancel: this.hideModalHM
        },
        _react2.default.createElement(
          "div",
          { className: "high-meter-body" },
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-L" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-title" },
              _react2.default.createElement(
                "span",
                null,
                "\u5DF2\u62CD\u6444"
              ),
              _react2.default.createElement(
                "button",
                { type: "button", onClick: this.deleteHandleFile },
                "\u5220\u9664\u5DF2\u9009(",
                deletedLength,
                ")"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-L-album" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-L" },
                _react2.default.createElement(_antd.Icon, {
                  type: "folder-open",
                  className: "icon-caret",
                  style: {
                    position: "absolute",
                    left: "27px",
                    top: "6px",
                    fontSize: "36px"
                  }
                }),
                _react2.default.createElement(_antd.Icon, {
                  type: "caret-right",
                  style: {
                    position: "absolute",
                    left: "85px",
                    top: "29px",
                    fontSize: "12px",
                    transform: "scale(.7)"
                  }
                })
              ),
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-L-album-R" },
                imgPathArray.length ? imgPathArray.map(function (item, index) {
                  return _react2.default.createElement(
                    "div",
                    { key: item, style: { position: "relative" } },
                    _react2.default.createElement("img", { width: "105", height: "85", src: item }),
                    _react2.default.createElement(_antd.Checkbox, {
                      defaultChecked: true,
                      onChange: function onChange(e) {
                        return _this6.handleCheckbox(e, deletePathArray[index], imgPathArray[index]);
                      }
                    })
                  );
                }) : _react2.default.createElement(
                  "div",
                  null,
                  "\u6CA1\u6709\u62CD\u7167"
                )
              )
            )
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-C" },
            imgVideo === "" ? _react2.default.createElement(
              "div",
              null,
              "\u6CA1\u8FDE\u63A5\u8BBE\u5907\u6216\u6CA1\u5F00\u542F\u9A71\u52A8\uFF0C\u8BF7\u5F00\u542F\u540E\u5237\u65B0\u5C1D\u8BD5"
            ) : _react2.default.createElement("img", { className: "bigPriDev", src: imgVideo })
          ),
          _react2.default.createElement(
            "div",
            { className: "high-meter-body-R" },
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-mode" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-mode-title" },
                "\u62CD\u7167\u6A21\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio,
                { checked: true, style: radioStyle, value: 1 },
                "\u5355\u5F20\u62CD\u6444"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-method" },
              _react2.default.createElement(
                "div",
                { className: "high-meter-body-R-method-title" },
                "\u547D\u540D\u65B9\u5F0F\uFF1A"
              ),
              _react2.default.createElement(
                _antd.Radio,
                { checked: true, style: radioStyle, value: 1 },
                "\u65E5\u671F\u547D\u540D"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-message" },
              _react2.default.createElement(
                "div",
                null,
                "\u5DF2\u62CD\u6570\u91CF\uFF1A",
                imgPathArray.length
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-action" },
              _react2.default.createElement(
                "button",
                {
                  type: "button",
                  className: "photoBtn",
                  onClick: this.onClickBtn
                },
                "\u5F00\u59CB\u62CD\u6444"
              )
            ),
            _react2.default.createElement(
              "div",
              { className: "high-meter-body-R-upload" },
              _react2.default.createElement(
                _yylibUi.YYButton,
                { onClick: this.handleUpload, type: "button" },
                "\u7ACB\u5373\u4E0A\u4F20"
              )
            )
          )
        )
      ),
      _react2.default.createElement(
        _yylibUi.YYModal,
        {
          title: preViewTitle.length === 0 ? preViewTitle[0] : preViewTitle[preViewTitleIndex],
          className: "previewModal",
          visible: this.state.visiblePreview,
          footer: null,
          onCancel: this.hideModalPreview
        },
        _react2.default.createElement(
          _antd.Carousel,
          {
            ref: function ref(dom) {
              _this6.swipeBigPic = dom;
            }
          },
          getUploadList ? getUploadList.map(function (item) {
            var mapSrc = void 0;
            _this6.fileSuffix(item.fileName) === "png" || _this6.fileSuffix(item.fileName) === "jpeg" || _this6.fileSuffix(item.fileName) === "jpg" || _this6.fileSuffix(item.fileName) === "ico" || _this6.fileSuffix(item.fileName) === "gif" || _this6.fileSuffix(item.fileName) === "bip" || _this6.fileSuffix(item.fileName) === "tiff" || _this6.fileSuffix(item.fileName) === "tga" || _this6.fileSuffix(item.fileName) === "eps" ? mapSrc = _urlUpload + "/" + item.filePath : mapSrc = [require("./file.png")];
            return _react2.default.createElement(
              "div",
              { key: item.gid },
              _react2.default.createElement("img", {
                className: "img-preview",
                title: item.fileName,
                alt: item.fileName,
                src: mapSrc
              })
            );
          }) : ""
        )
      )
    );
  }
});
module.exports = AttachMgrModalNew;